(define-module (ui mastercontrol viewparams ajax)
  :use-module (alterator ajax)
  :use-module (srfi srfi-1)
  :use-module (alterator woo)
  :export (init))

(define (read-values source hostid)
  (catch/message
    (lambda ()
      (form-update-enum "values" (woo-list (string-append "/mastercontrol/values/" source)
                                           'hostid hostid)))))

(define (read-host source hostid)
  (catch/message
    (lambda ()
      (let* ((data (woo-read-first (string-append "/mastercontrol/host/" source)
                                   'hostid hostid)))
        (form-update-value "hostid" (woo-get-option data 'id))
        (form-update-value "hostname" (woo-get-option data 'hostname))
        (let ((ip (woo-get-option data 'ip))
              (dnsname (woo-get-option data 'dnsname)))
          (form-update-value "ip" ip)
          (form-update-value "dnsname" dnsname)
          (form-update-value "ipordns" (or (and ip (not (string-null? ip)) ip)
                                           (and dnsname (not (string-null? dnsname)) dnsname))))
        (form-update-value "status" (case (string->symbol (woo-get-option data 'status))
                                      ((monitored) (_ "monitored"))
                                      ((notmonitored) (_ "not monitored"))
                                      ((template) (_ "template"))
                                      ((active-proxy) (_ "active-proxy"))
                                      ((passive-proxy) (_ "passive-proxy"))
                                      (else (_ "unknown"))))))))

(define (init)
  (let* ((hostidarg (form-value "hostidarg"))
         (source/hostid (string-split hostidarg #\/))
         (source (string-join (drop-right source/hostid 1) "/"))
         (hostid (last source/hostid)))
    (form-update-value "source" source)
    (read-host source hostid)
    (read-values source hostid)))
